ALTER TABLE FW_SYS_STAT_FSM_ACTIONS DROP CONSTRAINT FSM_ACTIONS_TYPE_ID_FK;
ALTER TABLE FW_SYS_STAT_FSM_ACTIONS DROP COLUMN TYPE_ID;
ALTER TABLE FW_SYS_STAT_FSM_ACTIONS ADD (STATE_ID NUMBER);
ALTER TABLE FW_SYS_STAT_FSM_ACTIONS
	ADD CONSTRAINT FSM_ACTIONS_STATE_ID_FK
	FOREIGN KEY (STATE_ID)
	REFERENCES FW_SYS_STAT_FSM_STATES(ID) ON DELETE CASCADE;

--Create tables for the auto-upgrade of the FW Component Installation Tool
CREATE TABLE FW_SYS_STAT_TOOL_UPGRADE
	(ID			NUMBER,
	PROJECT_ID 	NUMBER NOT NULL,
	SOURCE_DIR 	VARCHAR2(512) NOT NULL,
	TARGET_DIR 	VARCHAR2(512),
	SAFE_MODE		NUMBER DEFAULT 0,
	REQUESTED_ON 	DATE,
	EXECUTED_ON 	DATE);

ALTER TABLE FW_SYS_STAT_TOOL_UPGRADE
	ADD CONSTRAINT TOOL_UPGRADE_ID_PK PRIMARY KEY(ID);

ALTER TABLE FW_SYS_STAT_TOOL_UPGRADE
	ADD CONSTRAINT PROJECT_TOOL_ID_FK
	FOREIGN KEY (PROJECT_ID)
	REFERENCES FW_SYS_STAT_PVSS_PROJECT(id);

CREATE SEQUENCE FW_SYS_STAT_TOOL_UPGRADE_SQ
	MINVALUE 1
	MAXVALUE 9999999
	START WITH 1
	INCREMENT BY 1
	NOCACHE;

ALTER TABLE fw_sys_stat_proj_install_comps
	ADD DEPENDENCIES_OK NUMBER;

ALTER TABLE fw_sys_stat_proj_install_comps
	ADD pending_postinstalls VARCHAR2(2000);

CREATE TABLE FW_SYS_STAT_PROJ_INST_LOG(
	PROJECT_ID NUMBER NOT NULL,
	TS DATE,
	LOG CLOB);

ALTER TABLE FW_SYS_STAT_PROJ_INST_LOG
	ADD CONSTRAINT FW_SYS_STAT_PROJ_LOG_PK
	PRIMARY KEY (PROJECT_ID);

ALTER TABLE FW_SYS_STAT_PROJ_INST_LOG
	ADD CONSTRAINT FW_SYS_STAT_PROJ_LOG_FK
	FOREIGN KEY (PROJECT_ID)
	REFERENCES FW_SYS_STAT_PVSS_PROJECT(ID);
	
ALTER TABLE FW_SYS_STAT_PVSS_PROJECT
	ADD INST_TOOL_STATUS NUMBER;
	
--Upgrade Schema version
CREATE OR REPLACE VIEW fw_sys_stat_schema (version) AS
	SELECT '4.1.3'
	FROM dual;

